/* sprintf verwenden zur Anzeige von Float-Werten auf dem LC-Display
 *  Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!! */
#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
#include <stdio.h>					// für sprintf

uint16_t adc_wert; 					// Wert vom AD-Converter
char lcdtext [20];					// Anzeigetext 20 Zeichen
// bei Deklaration mit uint8_t (auch int8_t ???) kommt ein Warning, da sprintf gerne in (signed) char schreiben möchte
float u;							// Spannung in Volt
int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe
  adc_init();						// Analog-Digital-Converter initialisieren
  delay_ms(500);					// warten bis LC bereit
  lcd_init();						// LC-Display initialisieren
  while(1U)							// Endlosschleife Hauptprogramm
  {
	  adc_wert = adc_in(0);					// Messwert vom ADC holen
	  port_write(P0,adc_wert);  			// Wert an LEDs dual anzeigen
	  u = adc_wert * 5.0/4096;				// Normierung auf 5V
	  lcd_setcursor (2,3);					// 2. Zeile, 3. Spalte
	  sprintf (lcdtext,"U = %4.3f V",u);	// Anzeigetext erzeugen, Spannung mit 4 Stellen, 3 Nachkommastellen
	  lcd_print (lcdtext);					// anzeigen
	  delay_ms (500);		    			// ruhigere Anzeige
  }//while
}//main
