/* sprintf verwenden zur Anzeige von Float-Werten auf dem LC-Display
 *  Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!!
 *  gleitende Mittelwertbildung  */
#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
#include <stdio.h>					// für sprintf
#define adc_kanal 0					// 0 für Verwendung Poti
uint16_t adc_wert; 					// Wert vom AD-Converter
char lcdtext [20];					// Anzeigetext 20 Zeichen
// bei Deklaration mit uint8_t (auch int8_t ???) kommt ein Warning, da sprintf gerne in (signed) char schreiben möchte
uint8_t z;							// Schleifenzähler
float u;							// Spannung in Volt
#define anzahl 20					// Anzahl der Werte für gleitende Mittelwertbildung
uint16_t mw [anzahl];				// Speicher für letzte <Anzahl> Messwerte
uint32_t mittelw;					// Mittelwert der letzten <Anzahl> Messwerte
int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe
  adc_init();						// Analog-Digital-Converter initialisieren
  delay_ms(500);					// warten bis LC bereit
  lcd_init();						// LC-Display initialisieren
  for (z=0;z<anzahl-1;z++) mw[z]=0; // Alle Messwertspeicher löschen
  while(1U)							// Endlosschleife Hauptprogramm
  {
	  adc_wert = adc_in(adc_kanal);						// Messwert vom ADC holen
	  for (z=0;z<anzahl-1;z++) mw[z]=mw[z+1];			// alte Messwerte um 1 Stelle im Speicher verschieben, ältester Messwert entfällt
	  mw[anzahl-1] = adc_wert;							// neuester Messwert in den Speicher
	  mittelw = 0;
	  for (z=0;z<anzahl;z++) mittelw = mittelw + mw[z]; // letzte <anzahl> Messwerte aufaddieren
	  mittelw = mittelw / anzahl;						// und Mittelwert bilden
	  port_write(P0,mittelw);  							// Wert an LEDs dual anzeigen
	  u = mittelw * 5.0/4096;							// Normierung auf 5V
	  lcd_setcursor (2,3);								// 2. Zeile, 3. Spalte
	  sprintf (lcdtext,"U = %4.3f V",u);				// Anzeigetext erzeugen, Spannung mit 4 Stellen, 3 Nachkommastellen
	  lcd_print (lcdtext);								// anzeigen
	  delay_ms (100);		    						// ruhigere Anzeige
  }//while
}//main
