/* Funktion Mittelwertbildung  von anzahl ADC-Werten des Poti links
 * Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!!*/
#include <XMC1100-Lib.h>						// Hilfsfunktionen für XMC1100
#include <stdio.h>								// für sprintf
#define adc_kanal 0								// 0 für Verwendung Poti
#define anzahlwerte 20							// Anzahl der Werte
uint16_t werte[anzahlwerte];					// Speicherung der Werte für Mittelwertbildung
uint16_t mittelw;								// Ergebnisspeicher für Mittelwert
char lcdtext[20];								// für sprintf und LCD-Ausgabe
uint16_t adcwert;								// vom ADC engelesene Werte
float spannung;									// Spannung in V als Gleitkommazahl

//-------------------- Funktion zur Mittelwertberechnung ------------------------------------------------
// Übergabe: Array der Werte, von denen der Mittelwert berechnet werden soll und Anzahl der Werte
// Achtung Ergebnis ist eine ganze Zahl!
uint16_t mittelwert (uint16_t *arr, uint8_t anzahl,uint16_t aktualwert)
{
	uint8_t i;										// Zähler
	uint32_t sum=0;									// Summe Achtung "größere" Variable notwendig!!!
	for (i=0;i<anzahl-1;i++) arr[i]= arr[i+1];		// alte Messwerte um 1 Stelle im Speicher verschieben, ältester Messwert entfällt
	arr[anzahl-1] = aktualwert;						// neuester Messwert in den Speicher
	for (i=0;i<anzahl;i++)	sum += arr[i];			// letzte <anzahl> Messwerte aufaddieren
													// geteilt durch Anzahl ist Mittelwert
	return  sum / anzahl;							// Rückgabewert
}
//-------------------- Hauptprogramm -----------------------------------------------------------------------
int main(void)
{
  uint8_t i;
  adc_init();										// Analoge Eingänge initialisieren
  adcwert = adc_in(adc_kanal);
  for (i=0;i<anzahlwerte;i++) werte[i]=adcwert;		// Messwert-Array initialisieren,
  delay_ms(500);									// warten bis LC bereit
  lcd_init();										// LC-Display initialisieren
  while(1U)											// Endlosschleife Hauptprogramm
  {
	  adcwert = adc_in(adc_kanal);
	  mittelw = mittelwert (werte,anzahlwerte,adcwert);		// gleitenden Mittelwert berechnen
	  spannung = 5.0/4096 * mittelw;						// Spannung berechnen
	  sprintf (lcdtext,"U = %4.3f V Mittelw",spannung);			// Ausgabetext erzeugen
	  lcd_setcursor (1,1);
	  lcd_print (lcdtext);									// anzeigen
	  spannung = 5.0/4096 * werte[anzahlwerte-1];						// Spannung berechnen
	  sprintf (lcdtext,"U = %4.3f V Wert n",spannung);			// Ausgabetext erzeugen
	  lcd_setcursor (2,1);
	  lcd_print (lcdtext);									// anzeigen
	  spannung = 5.0/4096 * werte[anzahlwerte-2];						// Spannung berechnen
	  sprintf (lcdtext,"U = %4.3f V Wert n-1",spannung);			// Ausgabetext erzeugen
	  lcd_setcursor (3,1);
	  lcd_print (lcdtext);									// anzeigen
	  spannung = 5.0/4096 * werte[anzahlwerte-3];						// Spannung berechnen
	  sprintf (lcdtext,"U = %4.3f V Wert n-2",spannung);			// Ausgabetext erzeugen
	  lcd_setcursor (4,1);
	  lcd_print (lcdtext);									// anzeigen

	  delay_ms(200);
  }//while
}//main
